#!/bin/bash
## set -xe # L'un ou l'autre. ##
killall -q aemenu-pango;sleep 0.1 ##

[ -f $MRUFrep/share/MRUF/FirstRun ] && $MRUFrep/bin/Get-Gtk-Theme.sh && exit

. /usr/local/MRUF-lst/share/MRUF/vars.GEN1

PATHBKP="$PATH";PATH="/usr/local/MRUF-lst/bin:/root/my-applications/bin:/opt/local/bin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin"

cd $MRUFrep/share/MRUF # Habillage par défaut & Variables # Default skin & Vars.
[ ! -f Fonte ] && echo "DejaVu" > Fonte;Caract="`head -1 $MRUFrep/share/MRUF/Fonte`"
[ ! -f Size ] && echo 16 > Size;Size="`head -1 $MRUFrep/share/MRUF/Size`"
[ ! -f Color ] && echo -e "bisque\nsnow" > Color
Color1="`head -1 $MRUFrep/share/MRUF/Color`";Color2="`tail -1 $MRUFrep/share/MRUF/Color`"

# LANG=en_CA.utf8 # Uncomment this line to force debugging / testing of the script in English.
# Re-comment this line for normal operation in your localized language.

NexistePas () {
case "${LANG:0:2}" in fr)TXTMSG4="
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"\t\t\t\t\t<span color='red'><span rise='-9000' underline='double'><i> Hum... </i></span></span>\" \" \"
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"Comme le registre des fichiers récents « recently-used.xbel » \" \" \"
cmd \"  ne contient rien encore, ou qu'il n'existe plus, ce script ne \" \" \"
cmd \"  peut rien afficher. Faites quelques opérations pour recréer  \" \" \"
cmd \"     ou repeupler le fichier « xbel » et réessayez plus tard. \" \" \"
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"\t\t\t     <span color='red'><i>~~~~~~~~~~~~~~</i></span>\" \"\"
cmd \" \" \" \"" ;;
	en|*)TXTMSG4="
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"\t\t\t\t<span color='red'><span rise='-9000' underline='double'><i> Hm... </i></span></span>\" \" \"
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"There is nothing in file recently-used.xbel right now\" \" \"
cmd \"  -- or it doesn't exist --, so this script can't display\" \" \"
cmd \"      anything yet. Please do a few operations to \" \" \"
cmd \"   recreate | repopulate the file and try again later. \" \" \"
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"\t\t     <span color='red'><i>~~~~~~~~~~~~~~</i></span>\" \"\"
cmd \" \" \" \"" ;;
esac
echo -e "$TXTMSG4" > /tmp/NexistePas
aemenu-pango -rc /tmp/NexistePas
exit; }

####
case "$@" in A|a|H|h)TitrE="                 ~~~~~~ $MRUFv ~~~~~~"
	ExecS="aemenu-pango & bcm (vovchik), bash (v.>= 4.2; Fox & al.),
     less (Greenwood), replaceit (Daniels), sfs_load (shinobar), UEx-
     tract (SFR), urxvt (v.>= 9.2; Lehmann & al.), file (Darwin & al.);"
     NavS="Chrom*, Firefox, Light, links2, Opera, Seamonkey"
	DonneeS=".mtpaint, (.)recently-used.xbel, geany.conf. ## Options :
     global_history.dat, bookmarks (links2 & MZ), sqlite*, history
     (Vivaldi, Chrom* et al.)."
	BashS="hic-et-nunc2.sh, CleanMTPaintHistory.sh, gpl3.sh,
     mc.sh, sqlitemanager.sh (BarryK), visionner-avec-less4c.sh, etc."
     FiN="  https://tinyurl.com/ycmxqvem; MRUF-lst: https://tinyurl.com/y8bfgfvv\e[0m\n
   #######################################################################"
	case "${LANG%_*}" in	en)echo -e "\n\n   $TitrE\n\n      Allows access to files and directories you used most recently
     (MRUF|MRUD). Usable within Puppy|Quirky with most WM's and FM's.
        This app can be a great time-saver in your daily computing.\n
       \e[33m(c) Christian L'Écuyer, alias « musher0 » (PuppyLinux forum),
       Gatineau (Qc), Canada, end of Oct.-beg. of Nov. 2012. # Edits:
      Oct. 15, Nov. 16 2013 to end of June - Aug. 11 2017 (v. 0.9.8.6).\e[0m
   \t       \e[33mGPL3: https://opensource.org/licenses/GPL-3.0\e[0m\n
   \t\t\t   \e[32m\e[4m~~~ Required ~~~\e[24m
   Execs: $ExecS\n     $NavS, and/or Vivaldi.\n\n   Data: $DonneeS\n\n   Bash Scripts: $BashS
         (I authored those scripts unless otherwise mentioned.)\n\e[0m
                \e[36m~~~  Credits, thanks and references  ~~~
      Icon: Puppus Dogfellow. ### Comments: BarryK, Lazy_Puppy, Mike
   Walsh, MochiMoppei, stu91, torm. ## Ref.: aemenu-pango & bcm (vovchik),
  $FiN
                    (Type 'Enter' to close this panel.)" ;;
     fr)echo -e "\n\n   $TitrE\n\n     Permet d'accéder aux répertoires et fichiers récemment utilisés.
    \t  S'utilise dans Puppy|Toutou|Quirky avec la plupart des
                 gestionnaires de fenêtres et de fichiers.
        Cette application peut vous faire gagner beaucoup de temps.\n
       \e[33m(c) Christian L'Écuyer, alias « musher0 » (forum PuppyLinux),
     Gatineau (Qc), Canada, fin oct. - début nov. 2012. ### Révisions :
        15 oct., 16 nov. 2013 à fin juin - 11 août 2017 (v. 0.9.8.6).
   \t       \e[33mGPL3 : https://opensource.org/licenses/GPL-3.0\e[0m\n
   \t\t\t      \e[32m\e[4m~~~ Requis ~~~\e[24m
   Exéc. : $ExecS\n     $NavS et / ou Vivaldi.\n\n   Données: $DonneeS\n\n   Scripts en bash : $BashS
       (Je suis l'auteur de ces scripts sauf indication contraire.)\n\e[0m
             \e[36m~~~  Crédits, remerciements et références  ~~~
   Icône : Puppus Dogfellow.  ##  Obs. : BarryK, Lazy_Puppy, Mike Walsh,
    MochiMoppei, stu91, torm.  ##  Réf. : aemenu-pango & bcm (vovchik),
  $FiN
                    (Taper 'Entrer' pour fermer ce panneau.)" ;;
     esac;read ;; # Description
###
	*)[ ! -f /root/.local/share/recently-used.xbel ] && NexistePas
	[ "`grep file $XBelsrc | wc -l`" = "0" ] && NexistePas
	# Vérification essentielle : si le fichier xbel existe et s'il contient des références à des fichiers.

## Si tout est beau, le script se met à l'ouvrage. / If everything ok, script gets to work.
	if [ "`ls -1 /tmp/Menu*`" != "" ];then
		[ "`ls -Algo /tmp/Menu* | awk '{ print $3 }' | tr "\n" " " | awk '{ print $1+$2+$3+$4 }'`" = "`cat /usr/local/MRUF-lst/share/MRUF/MenusMZSize`" ] || $MRUFrep/bin/sqlite3-places-5a.sh &
	# Si la somme des tailles est différente, on lance l'adjoint'. Fait gagner un peu de temps.
	else
		[ -d /root/.mozilla -o -d /root/.light ] && $MRUFrep/bin/sqlite3-places-5a.sh &
	# Prépare les sous-menus MZ en fond de scène.
	fi # Voir ligne 370.

	if [ ! -f SqlitE ];then
		[ -f $MRUFrep/bin/sqlitemanager.sh ] && echo "$MRUFrep/bin/sqlitemanager.sh" > SqlitE
	fi
	[ -f SqlitE ] && SqlitE="`head -1 $MRUFrep/share/MRUF/SqlitE`"

# For file managers # Thanks to Mike Walsh for this suggestion. # Sept. 5 2016
	[ ! -f FileMan ] && echo rox > $MRUFrep/share/MRUF/FileMan;FM="`head -1 $MRUFrep/share/MRUF/FileMan`"
	SpaN2="</span></span>"

# Construction du menu # En-tête
	> /tmp/en-tete
	echo -e "### aemenu ###\n# This is a dynamic file! # Ce fichier change tout le temps !
# Do not edit directly.  # # Ne pas éditer directement.\n# aemenu pour MRUF-lst.*
# ${LANG%_*} \n" > /tmp/en-tete

case "${LANG%_*}" in fr)DOCREC=" Documents récents"
		DaT="`date '+%a. %d %b. %Y'`" ;;
	en|*)DOCREC=" Recent Documents "
		DaT="`date '+%a. %b. %d %Y'`" ;;
esac
sleep 0.1s
echo -e "cmd \"   <span color='$Color2'><span rise='9000' underline='double'><i> $DaT </i></span></span>\" \"$MRUFrep/bin/hic-et-nunc2.sh;$MRUF\"" >> /tmp/en-tete
LC_ALL=C #
LarGEcran="`xwininfo -root | awk '$1 ~ /Width/ { print $2 }'`";CutOff=1024
if [ "$LarGEcran" -gt "$CutOff" ];then # Wider / narrower screens
	echo -e "menu \" <span rise='9000' font='$Caract bold $Size'><span color='$Color1'><i>$DOCREC</i>$SpaN2\"" >> /tmp/en-tete
else
	echo -e "cmd \" <span rise='9000' font='$Caract bold $Size'><span color='$Color1'><i>$DOCREC</i>$SpaN2\" \" \" " >> /tmp/en-tete
fi

# Corps
	[ ! -f $corps -o "`grep -ow ${LANG%_*} /tmp/en-tete`" = "" ] && CndtN1="non" || CndtN1="oui"
	[ "`ls -Algo $XBelsrc | awk '{ print $3 }'`" != "`cat XbelSize`" 	-o "`ls -AlgoH $MRUF | awk '{ print $3 }'`" != "`cat ScriptSize`" ] && CndtN2="non" || CndtN2="oui"
	[ "`ls -Algo /root/.config/geany/geany.conf | awk '{ print $3 }'`" != "`cat /root/.config/geany/Size.geany.conf`" -o "`ls -Algo /root/.mtpaint | awk '{ print $3 }'`" != "`cat /root/Size.mtpaint`" ] && CndtN3="non" || CndtN3="oui"
	if [ "$CndtN1" = "non" -o "$CndtN2" = "non" -o "$CndtN3" = "non" -o "$CndtN4" = "non" ];then
	# See Size stamps towards end of script. For detection of menu existence, language, freshness, script editing, etc.

# Attente
		case "${LANG%_*}" in fr)TXTMSG3="

Le menu doit être mis à jour.
... Merci de votre patience ...
" ;;
			en|*)TXTMSG3="

The menu must be updated.
... Thanks for waiting ...
" ;;
		esac
		bcm -u /usr/local/MRUF-lst/share/pixmaps/mrudicon2-48x-trnsprnt.png -a 1 -g c:c -d 3 -b "#000000FF" -c "#0c0c0c8F" -t "<span font='LiberationSerif Bold Italic 18' color='$Color1' gravity='north' gravity_hint='line'>$TXTMSG3</span>" 2>/dev/null &

# Variables
		. /usr/local/MRUF-lst/share/MRUF/vars.GEN2
		[ ! -L $XBel ] && ln -s /root/.local/share/recently-used.xbel $XBel

		LnG="${LANG%_*}";[ "$LnG" != "fr" -a "$LnG" != "en" ] && LnG="en" # Langue
				. /usr/local/MRUF-lst/share/MRUF/vars.$LnG
# Read file / Lire le fichier # /usr/share/doc/MRUF-lst/MRUF-langues.txt
# to implement other languages. / pour implémenter d'autres langues.

# Fonctions
		RplaciT () { replaceit --input=${j} "/initrd/mnt/dev_save" "/mnt/home"; }
##
		EnD  () {
echo "end
" >> $corps;	}
##
		tITRe () { echo -e "
menu \"$SpanSizE2<i> ${j}</i>$SpaN2\"\n\t$LignESpaN" >> $corps; }
##
		dIRs () { dir="";
for dir in `cat ${j}`;do
	if [ -d "${dir#*//}" ];then A="${dir#*//}"
		if [ "${#A}" -gt 55 ];then
			A="${A:35:${#A}}"
			echo -e "\tcmd \"...$A\" \"$FM '${dir#*//}'\"" >> $corps
		else
			echo -e "\tcmd \"${dir#*//}\" \"$FM '${dir#*//}'\"" >> $corps
		fi
	fi
done; }
##
		MRUD () { k="";k="${j}";j="";j="/tmp/MRUFprog";
RplaciT
j="";j="${k}";i=""
while read i;do
	if [ -f "$i" ];then A="${i}"
		if [ "${#A}" -gt 45 ];then # Long lines. / Lignes longues.
			A="...${A:35:${#A}}"
			echo -e "\tcmd \"$A\" \"default${j}editor '${i}'\"" >> $corps
		else
			echo -e "\tcmd \"${i}\" \"default${j}editor '${i}'\"" >> $corps
		fi
	fi
done < /tmp/MRUFprog
echo -e "\t$LignESpaN" >> $corps
j="";j="⚫ M. R. U. Dirs";tITRe
> /tmp/MRUDprog
i=""
for i in `cat /tmp/MRUFprog | grep -v recent_files`;do
	[ -f "$i" ] && dirname $i >> /tmp/MRUDprog
done
k="";k="${j}";j="";j="/tmp/MRUDprog2"
sort -u /tmp/MRUDprog > ${j}
RplaciT;dIRs;j="${k}";EnD; }
##
		DefEdVieW () {
echo -e "\tcmd \"   default${j}editor\" \"default${j}editor;$MRUF\"
	cmd \"   default${j}viewer\" \"default${j}viewer;$MRUF\"
	$LignESpaN\n" >> $corps
EnD; }
##
		Shorten () { V="${file#*//}";V="`echo ${V} | awk -F"/" '{ print "..."$(NF-2)"/"$(NF-1)"/"$NF }'`"; } # Long lines.
##
		FilHndlR () {
if [ -f "${file#*//}" ];then
	if [ "`file -b ${file#*//} | awk '/package|compression/'`" ];then
		#	if [[ "${file#*//}" =~ .*pet.* ]];then # Façon regex. # Note pour moi.
		Shorten
		echo -e "\tcmd \"${V}\" \"/usr/local/apps/UExtract/AppRun '${file#*//}';$MRUF\"" >> $corps
	elif [ "`file -b ${file#*//} | awk '/Squashfs/'`" ];then Shorten
		echo -e "\tcmd \"${V}\" \"sfs_load '${file#*//}';$MRUF\"" >> $corps
	elif [ "`file -b ${file#*//} | awk '/[Zz]ip/'`" ];then Shorten
		echo -e "\tcmd \"${V}\" \"xarchive '${file#*//}';$MRUF\"" >> $corps
	elif [ "`file -b ${file#*//} | awk '/text/'`" ];then Shorten
		echo -e "\tcmd \"${V}\" \"defaulttextviewer '${file#*//}';$MRUF\"" >> $corps
	elif [ "`file -b ${file#*//} | awk '/image/'`" ];then Shorten
		echo -e "\tcmd \"${V}\" \"defaultimageviewer '${file#*//}';$MRUF\"" >> $corps
	else
		Shorten;echo -e "\tcmd \"${V}\" \"xdg-open ${file#*//};$MRUF\"" >> $corps
	fi
fi; }
##
		BacKuP () { BkP="";BkP="cp -f --backup ${j} ${j}.bkp";
echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"
\tcmd \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"$BkP;rm -f ${j};rm -f $corps;$MRUF\"
	$LignESpaN" >> $corps
EnD; }
##
		BkPLine (){
echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"" >> $corps; }
##
		EffacE () {
echo -e "\tcmd  \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"$BkP;Clean${j}History.sh;rm -f $corps;$MRUF\"
	$LignESpaN" >> $corps; }
##
		gMplyR () { j="";j="${k}/mplayer.lst";
> ${j}
gui=""
for gui in gui.${ending};do
	[ "`wc -l < $gui`" -gt "0" ] && cat $gui >> ${k}/mplayer.lst
	RplaciT
done
sort -u ${j} | head -n 7 > /tmp/MRUFprog; }
##
		ChoiX () {
echo -e "\t$LignESpaN\n	cmd \"$DSeaGR<i> ⚫ $ChoiX  </i>$SpaN2\" \" \"\n\t$LignESpaN
" >> $corps; }
##
		EcourtE () {
if [ "${#http}" -gt 60 ];then
	V=$http;V="${V:8:20}";l="`echo $[${#http} - 25]`";W="${http:$l:${#http}}"
	echo -e "\tcmd \"...$V...$W\" \"$browser $http\"" >> $corps
else echo -e "\tcmd \"...${http:8:${#http}}\" \"$browser $http\"" >> $corps
fi; }  # Thanks to forum member torm for the idea.
##
		CopieRes () {
echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup ${j} ${j}.bkp;$MRUF\"
	$LignESpaN " >> $corps
	EnD; }
##
		LecteursMedia () { for exec in audio media video;
do
	[ -f /usr/local/bin/default${exec}player ] && echo -e "\tcmd \"  default${exec}player  \" \"default${exec}player;$MRUF\"" >> $corps
done; }

###
#### We build! | On construit ! :-)
	> $corps
		echo -e "\t$LignESpaN" >> $corps
		j="";j="⚫ ' xbel '";tITRe
#
		j="";j="⚫ $FiL";tITRe
		if [ "`awk -F'\"' '$0 ~ /href/ && $2 !~ /'${PicS}'|\.sh|MRUF|init|etc|recents/ { print $2 }' $XBel | wc -l`" != "0" ];then
			> /tmp/dir-catalog
			file="";for file in `awk -F"\"" '/href/ && $2 !~ /'${PicS}'|\.sh|MRUF|init|etc|recents/ { print $2 }' $XBel | tail -n 14`;do
				FilHndlR
				[ "${file#*//}" = "" ] || dirname "${file#*//}" >> /tmp/dir-catalog # Prép. pour M.R.U.D., 3e ci-dessous.
			done
			echo -e "\t$LignESpaN
	cmd \"$SpanSizE3<i>⚫ ($FichRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		fi
		EnD # General files
#
		j="";j="⚫ images";tITRe
		file="";for file in `awk -F"\"" '$2 ~ /'${PicS}'/ { print $2 }' $XBel | tail -n 14`;do
			FilHndlR
		done
		echo -e "\t$LignESpaN
	cmd \"$SpanSizE3<i>⚫ ($ImGRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Images
#
		j="";j="⚫ $apps";tITRe #
		for app in `awk -F";" '$1 ~ /exec/ { print $2 }' $XBel | awk '{ print $1 }' | sort -u`;do
			[ "`which $app`" ] && echo -e "\tcmd $app \"$app;$MRUF\"" >> $corps
		done;
		echo -e "\t$LignESpaN
	cmd \"$SpanSizE3<i>⚫ ($ApPRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Apps
#
		j="";j="⚫ scripts";tITRe
		awk -F"\"" '$2 ~ /\.sh/ && $2 !~ /MRUF/ { print $2,$(NF-1) }' $XBel | awk -F"T" '{ print $1 }' | sort -u -r -k 2 | head -n 14 | awk '{ print $1 }' > /tmp/scripts.xbel
		while read line;do
			line="${line:7:${#line}}"
			[ "`which $line`" ] && echo -e "\tcmd ${line##*/} \"defaulttexteditor $line\"" >> $corps
		done < /tmp/scripts.xbel
		echo -e "\t$LignESpaN
	cmd \"$SpanSizE3<i>⚫ ($ScrpTRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Scripts
		echo -e "\t$LignESpaN" >> $corps
#
	j="";j="⚫ M. R. U. Dirs";tITRe
	j="";j="/tmp/dir-catalog";RplaciT
	k="";k="${j}";j="";j="/tmp/dir-catalog.uniq"
	sort -u ${k} > ${j}
	dIRs;echo -e "\t$LignESpaN
	cmd \"$SpanSizE3<i>⚫ ($DiRRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
	EnD # MRUD

	j="";j="⚫ $UtiliT";tITRe
	j="";j="$XBelsrc";BacKuP
	echo -e "\t$LignESpaN" >> $corps
	EnD # End of general section | Fin de la section générale | xbel.
###
		j="";j="⚫ URLs";tITRe # URLs
##
		NamE="global_history.dat";DiR="/root/.opera/profile"; # Pour le vieil opera.
		OprAHsT="`find /root/.opera/profile -maxdepth 1 -name global_history.dat 2>/dev/null | head -1`"
		if [ "$OprAHsT" = "" ];then
			OprAHsT="`find /mnt/sd*/opera*/pro* -maxdepth 1 -name global_history.dat 2>/dev/null | head -1`"
		fi
		if [ "$OprAHsT" != "" ];then # If we have something, we create the sub-menu.
			j="";j="⚫ Opera-12.x";tITRe;
			browser=opera;http="";
			for http in `awk '/http/ && $1 !~ /'${aVOId}'/' $OprAHsT | head -n 14`
				do	EcourtE
			done
			echo -e "\t$LignESpaN" >> $corps

		j="";j="⚫ $UtiliT";tITRe
		echo -e "\tcmd \"$HistoriQ\" \"opera about:history\"" >> $corps
		BkPOpera="cp -f --backup $OprAHsT $OprAHsT.bkp"
		echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkPOpera;$MRUF\"
	cmd \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"[ "`ps | awk '$4 ~ /opera/'`" = "" ] && $BkPOpera && rm -f $OprAHsT;rm -f $corps;$MRUF\"" >> $corps # Erasing works only if opera is not loaded.
		echo -e "\tcmd \"opera\" \"opera;$MRUF\"\n\t$LignESpaN" >> $corps
		EnD
		echo -e "\t$LignESpaN" >> $corps;EnD
		fi # End, opera-12.x section
##
		browser="";for browser in links light mozilla;do
			backup="${browser}" # On fait une sauvegarde.
			k="/root/.$browser/bookmarks.html"
			if [ -f $k ];then j="";j="⚫ $browser";tITRe
				[ "${browser}" = "links" ] && browser="links2 -g"
				http="";
				for http in `awk -F'\"' '$2 ~ /http/ && $2 !~ /'${aVOId}'/ { print $2 }' $k | tail -n 14`
					do	EcourtE
				done
				[ "`ls /tmp/Menu$browser 2>/dev/null`" ] && cat /tmp/Menu"$browser" >> $corps
				echo -e "\tcmd \"$SpanSizE4<i>⚫ (pseudo-$HistoriQ)</i>$SpaN2\" \"$MRUF\"
	$LignESpaN" >> $corps

		j="";j="⚫ $UtiliT";tITRe
		echo -e "\tcmd \"  $SignetS\" \"$browser file://$k;$MRUF\" " >> $corps
		BkP="";BkP="cp -f --backup ${k} ${k}.bkp";BkPLine
		if [ "${browser}" = "mozilla" ];then
			echo -e "\tcmd \"  $NavDef\" defaultbrowser" >> $corps
		else
			echo -e "\tcmd \"  $MZbr\" \"$browser\"" >> $corps
		fi
		echo -e "\t$LignESpaN" >> $corps;EnD
		echo -e "\t$LignESpaN" >> $corps;EnD
			fi
			[ "${browser}" = "${backup}" ] || browser="${backup}" # On restaure au besoin.
		done
##
		browser="";for browser in chrome chromium opera vivaldi;do # si vivaldi installé DANS le système.
			if [ "`which $browser`" ];then # Based on peebee's chromium-60 sfs.
		# Regrouper sections Chrome, Chromium et Vivaldi.
			j="";j="⚫ $browser";tITRe
			echo -e "\tcmd \"$HistoriQ\" \"$browser --user-data-dir=~/.config/$browser $browser://history;$MRUF\"" >> $corps
		cDH="/root/.config/$browser/Default/History"
		echo -e "cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $cDH $cDH.bkp;$MRUF\"
	$LignESpaN\n	cmd \"  $MZbr\" \"$browser --user-data-dir=~/.config/$browser\"" >> $corps
		EnD;fi
		done # Fin de la section Chromium / End of Chromium section.
##
	#	Personnalisation seulement # If you have Vivaldi on /mnt/home or other partition.
		ViV="`find /m* /u* -maxdepth 4 -name vivaldi-bin 2>/dev/null | head -1`";ViV="`dirname $ViV`" #
		if [ "$ViV" != "" ];then j="";j="⚫ Vivaldi";tITRe
			echo -e "\tcmd \"$HistoriQ\" \"cd $ViV;./vivaldi --no-sandbox --enable-grouped-history --user-data-dir=profile vivaldi://history;MRUF\"" >> $corps
			pDH="profile/Default/History"
			echo -e "cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cd $ViV;cp -f --backup $pDH $pDH.bkp;$MRUF\"
	$LignESpaN\n	cmd \"  $MZbr\" \"cd $ViV;$ViV/lancer.sh\"" >> $corps
		EnD
		fi # End, Vivaldi section # Rev. July 23 2017
##
		echo -e "\t$LignESpaN\n\tcmd \"  defaultbrowser\" \"defaultbrowser;$MRUF\"
	cmd \"  defaulthtmlviewer  \" \"defaulthtmlviewer;$MRUF\"" >> $corps
		EnD # URLs
###
		j="";j="⚫ $APPS";tITRe
#
		if [ -f /usr/bin/gmplayer ];then MplayeR="gmplayer" # Tester aussi avec smplayer :
			# [ -f /usr/bin/gmplayer ] && MplayeR="gmplayer" || MplayeR="smplayer"
			j="";j="⚫ gMPlayer";tITRe
			echo -e "\tcmd \"$SpanSizE3<i>⚫ $MPlyRFils</i>$SpaN2\" \" \"" >> $corps
			k="";k="/root/.mplayer";cd ${k}
			ending="";ending="url";gMplyR # Radios et autres # Aussi gui.pl? Non.
			media="";for media in `cat /tmp/MRUFprog`;do
				echo -e "\tcmd \"${media##*/}\" \"$MplayeR $media;$MRUF\"" >> $corps
			done
			echo -e "\t${LignESpaN}" >> $corps
			j="";j="⚫ M. R. U. Dirs";tITRe
			ending="";ending="history";gMplyR  # For directories
			media="";for media in `cat /tmp/MRUFprog`;do
				echo -e "\tcmd \"${media##*/}\" \"rox $media;$MRUF\"" >> $corps
			done;EnD
			echo -e "\t$LignESpaN
	\tcmd  \"$DSeaGR<i> ⚫ $EFFs  </i>$SpaN2\" \"CleanMPlayerHistory.sh;rm -f $corps;$MRUF\"
	\tcmd  \"$DSeaGR<i> ⚫ $EDTs  </i>$SpaN2\" \"defaulttexteditor ${k}/gui.history ${k}/gui.url;$MRUF\"
	\t$LignESpaN" >> $corps
			LecteursMedia
			EnD
		fi # End, MPlayer section
#
		k="";k="/root/.config/geany/geany.conf"
		if [ -f ${k} ];then # Skipped if no Geany.
			j="";j="⚫ Geany";tITRe;cd "${k%/*}"
			grep t_files= "${k##/*/}" | tr ";" "\n" | grep -v MRUF | head -n 14 > /tmp/MRUFprog
			echo -e "\tcmd \"$SpanSizE3<i>⚫ (Textes récents [' geany '])</i>$SpaN2\" \" \"" >> $corps
			j="";j="text";MRUD

		j="";j="⚫ $UtiliT";tITRe
		k="";k="/root/.config/geany/geany.conf"
		echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup ${k} ${k}.bkp;$MRUF\"" >> $corps
		j="";j="Geany";BkP="";BkP="cp -f --backup ${k} ${k}.bkp"
		EffacE # Erasing works only if program not running.
		j="";j="text";DefEdVieW;echo "$LignESpaN" >> $corps
		EnD
			fi # End, Geany section
#
		k="";k="/root/.mtpaint"
		if [ -f ${k} ];then # Skipped if no mtpaint.
			j="";j="⚫ Mtpaint";tITRe
			awk '$1 ~ /^file/ && $0 !~ /MRUF/ { print $3 }' ${k} | head -n 14 > /tmp/MRUFprog
			echo -e "\tcmd \"$SpanSizE3<i>⚫ ($ImGRecnt [' mtpaint '])</i>$SpaN2\" \" \"" >> $corps
			j="";j="image";MRUD
		j="";j="⚫ $UtiliT";tITRe
		k="";k="/root/.mtpaint";BkP="";BkP="cp -f --backup ${k} ${k}.bkp"
		echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"" >> $corps
		j="";j="MTPaint";EffacE # Erasing works only if program not running.
		j="";j="image";DefEdVieW;echo "$LignESpaN" >> $corps
		EnD
			fi # End, MtPaint section
###
		j="";j="⚫ SQLite3";tITRe
		[ "`ls -1 ~/.*/*/*.default/extensions/SQLiteManager@mrinalkant.blogspot.com.xpi`" ] && echo -e "\tcmd \" SQLiteManager\" \"sqlitemanager.sh;$MRUF\"" >> $corps
		echo -e "\tcmd \" $RfrMZ\" \"$MRUFrep/bin/sqlite3-places-5a.sh;rm -f $corps;$MRUF\"\n	\t$LignESpaN" >> $corps
		EnD # SQLite3 section
###
  		if [ -f ~/.config/vlc/vlc-qt-interface.conf ];then
			j="";j="⚫ vlc";tITRe
			echo -e "\tcmd \"$SpanSizE3<i>⚫ ($MediaRecnt [ vlc ] )</i>$SpaN2\" \" \"" >> $corps
			cd ~/.config/vlc
			awk -F= '$1=="list" { print $2 }' vlc-qt-interface.conf | tr , "\n" > /tmp/MenuVlc0
			cat /tmp/MenuVlc0 | tr -s " " > /tmp/MenuVlc
			> /tmp/vlcReps
			while read line;do
				if [ "`echo $line | awk /file/`" ];then
					linebkp="$line";line="${line:7:${#line}}" # echo $line
					nom="`echo $line | awk -F"\/" '{ print $NF }'`" # We check existence of file.
					[ "`ls -1 $line 2>/dev/null`" ] && echo -e "\tcmd $nom \"vlc $linebkp\"" >> $corps
					dirname $line >> /tmp/vlcReps
				elif [ "`echo $line | awk /dvd/`" ];then # We need precision here.
					nom="`echo $line | awk -F"\/" '{ print $NF }'`"
					echo -e "\tcmd $nom \"vlc $line\"" >> $corps
				# elif [ "`echo $line | awk /???/`" ];then
				fi
			done < /tmp/MenuVlc
			rm /tmp/MenuVlc0 # We keep the other one as ref.
			echo -e "\t$LignESpaN" >> $corps
		j="";j="⚫ M. R. U. Dirs";tITRe
		media="";for media in `cat /tmp/vlcReps`;do
			[ "`ls -1 $media 2>/dev/null`" = "" ] || echo -e "\tcmd \"${media##*/}\" \"rox $media;$MRUF\"" >> $corps
			done
			EnD

		j="";j="⚫ $UtiliT";tITRe
		k="";k="~/.config/vlc/vlc-qt-interface.conf";BkP="";BkP="cp -f --backup ${k} ${k}.bkp"
		echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"\n\t$LignESpaN
	cmd \"  vlc\" vlc" >> $corps
		LecteursMedia
		echo "end\n\t$LignESpaN" >> $corps
		EnD
		fi
		EnD # vlc section
###
		echo -e "\t$LignESpaN" >> $corps
		EnD # Apps section
###
		j="";j="⚫ bash+Syst.";tITRe
		k="";for k in bash-bash_history less-lesshst noX_console-history;do
			j="";j="⚫ ${k%-*}";tITRe;j="";j=".${k#*-}"
			[ -f /root/"${j}" ] && echo -e "\tcmd \"    $HIST\" \"visionner-avec-less4c.sh  /root/${j};$MRUF\"" >> $corps
			BacKuP
			echo -e "\t$LignESpaN" >> $corps
		done
#
		j="";j="⚫ ' xerrs.log '";tITRe;j="";j="/tmp/xerrs.log"
		echo -e "\tcmd \"    xerrs.log\" \"visionner-xerrs_log-2c.sh;$MRUF\"" >> $corps
		CopieRes
		j="";j="⚫ ' Xorg.log '";tITRe;j="";j="/var/log/Xorg.0.log"
		echo -e "\tcmd \"    Xorg.log\" \"visionner-avec-less4c.sh ${j};$MRUF\"" >> $corps
		CopieRes
#
	echo -e "\t$LignESpaN\n\tcmd \"   console\" \"$TERM;$MRUF\"
	cmd \"   less\" \"visionner-avec-less4c.sh $MRUFrep/share/MRUF/NQuelTxt;$MRUF\"
	cmd \"   $InviT\" \"killall X || killall Xorg\"" >> $corps
	EnD # Terminal
###
		j="";j="⚫ $LasT14";tITRe
		j="";j="⚫ $PaquetS";tITRe;cd /root/.packages
		[ "{LANG:0:2}" != "en" ] && LC_ALL=""
		ls -Algot *.files | head -n 14 | awk -F. '{ print $1 }' | awk '{ print $5,$4,$7 }' > /tmp/liste-PPM
		while read line;do
			echo -e "\tcmd \"${line% *} – ${line##* }\" \"visionner-avec-less4c.sh /root/.packages/${line##* }.*.files\"" >> $corps # —
		done < /tmp/liste-PPM
		echo -e "\t$LignESpaN\n\tcmd \"$PpM\" ppm\n\t$LignESpaN" >> $corps
		EnD # End, 14 last packages installed by petget
#
		j="";j="⚫ $MyDocS";tITRe
		cd ~/my-documents
		ls -Algot | grep -v -E "lrw|drw|total" | head -n 14 | awk '{ print $5,$4,$7 }' > /tmp/liste-Mes-docs
	#	ls -Algot | awk '$1 !~ /lrw|drw|total/ { print "\tcmd \""$5,$4" – "$7"\" \" rox ~/my-documents/"$7 }' | awk 'NR<=14' >> $corps # Prend 13/100 de sec. de plus que la forme avec while.
		while read line;do
			echo -e "\tcmd \"${line% *} – ${line##* }\" \"rox ~/my-documents/${line##* }\"" >> $corps
		done < /tmp/liste-Mes-docs
		[ "{LANG:0:2}" != "en" ] && LC_ALL=C
		echo -e "\t$LignESpaN\n\tcmd \"$MyDocS\" \"rox ~/my-documents\"\n\t$LignESpaN" >> $corps
		EnD;echo -e "\t$LignESpaN" >> $corps # End, 14 last personal docs.
		EnD;echo -e "\t$LignESpaN" >> $corps # End, "14 Last" section
#
		[ "$LarGEcran" -gt "$CutOff" ] && EnD # For narrower monitors / Pour moniteurs plus étroits.
###
		echo -e "\t$SeaGreeN" >> $corps;j="";j="\t      $HlP";tITRe
		echo -e "\tcmd \"$SpanSizE2<i>   MRUF-lst (Description $CRDTS)</i>$SpaN2\" \"urxvt -$FnT -title 'MRUF-lst - Description & Credits' -bg '#49301A' -$ClR -g 80x35 -b 20 +uc -bc +sb -e MRUF-lst h;$MRUF\"$LignESpaN" >> $corps
#
		for ligne in "$LigN1" "$LigN2" "$LigN3";do
			echo -e "\tcmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done
		echo -e "\t$LignESpaN\n\tcmd \"$SpanBolD<i>$LigN7</i>$SpaN2\" \" \"
	$LignESpaN\n\tcmd \"$SpanBolD<i>$LigN6</i>$SpaN2\" \" \"" >> $corps
		[ "`which chromium`" ] && echo -e "\t$LignESpaN\n\t	cmd \"$SpanBolD<i>$MayNoTLanD</i>$SpaN2\" \" \"" >> $corps
		echo -e "\t$LignESpaN" >> $corps;ligne=""
		for ligne in "$LigN8" "$LigN9" "$LigN10" "$LigN11" "$LigN12";do
			echo -e "\tcmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done
		echo -e "\t$LignESpaN" >> $corps;ligne=""
		for ligne in "$LigN13" "$LigN14" "$LigN15";do
			echo -e "\tcmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done
		echo -e "\t$LignESpaN\n\tcmd \"$SpanBolD<i>$LigN16</i>$SpaN2\" \" \"
	$LignESpaN\n	cmd \"$SpanBolD<i>$LigN17</i>$SpaN2\" \" \"\n" >> $corps
		echo -e "\t$LignESpaN" >> $corps;ligne=""
		for ligne in "$LigN18" "$LigN19";do echo -e "\tcmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done
		echo -e "\t$LignESpaN\n	cmd \"$SpanSizE2<i>   $LiC</i>$SpaN2\" /usr/share/doc/MRUF-lst/gpl3.sh
	$LignESpaN" >> $corps;EnD # End of Help section. / Fin de la section d'aide.
##
		j="";j="Param.";	LarG="                  "
		# Diff="`echo $[${#LarG} - ${#j}]`" # echo $Diff
		# DemiDiff="`echo $[$Diff / 2]`" # echo $DemiDiff
		# QuartDiff="`echo $[$DemiDiff / 2]`" # echo $QuartDiff
		# TiersDiff="`echo $[$DemiDiff / 3]`" # echo $TiersDiff
		# j="${LarG:0:$DemiDiff}${LarG:0:$QuartDiff}${LarG:0:$TiersDiff}$j"
		j="${LarG:0:11}$j";tITRe # echo "$j"

		j="";j=" $HabiT";tITRe;j="";j="  $ClRs";tITRe
		cd $MRUFrep/share/MRUF
		for i in `ls -1 ColorSc* | grep -v Active`;do ColorA="`head -1 $i`";ColorB="`tail -1 $i`"
			echo -e "\tcmd \"<span fgcolor='$ColorA'><i>  $SchM</i><span fgcolor='$ColorB'><i> $i </i>$SpaN2\" \"cat $i > Color;rm -f *Active;cp -f $i $i§Active;rm -f $corps;$MRUF\"" >> $corps
		done;ChoiX;EnD # Colors / Couleurs
#
		j="";j="  $Taille";tITRe
		for i in 14 15 16 17;do echo -e "\tcmd \"    $i\" \"echo -n $i > $MRUFrep/share/MRUF/Size;rm -f $corps;$MRUF\"" >> $corps
		done;ChoiX;EnD # Font sizes / Tailles de la fonte
#
		echo -e "\t$LignESpaN\n\tcmd \"  GTK chtheme\" \"gtk_chtheme_wrapper;Get-Gtk-Theme.sh;exit\"
   \tcmd \"  $FixColors\" \"Get-Gtk-Theme.sh;exit\"" >> $corps
		EnD # Dress-up
###
		j="";j=" $FileMan";tITRe
		for flmngr in MidnightCommander_mc.sh PcMan_pcmanfm ROX-Filer_rox Xfe_xfe;do
# Add any FM that you are use by following above pattern. /
# Ajouter tout gest. de fich. que vous utilisez en suivant le patron ci-dessus.
			[ "`which ${flmngr#*_}`" ] && echo -e "\tcmd \"   ${flmngr%_*}\" \"echo ${flmngr#*_} > $MRUFrep/FileMan;$MRUF\"" >> $corps
		done # < which > to prevent accidents. / Pour prévenir les accidents.
		ChoiX;EnD # FileManagers
		echo -e "$LignESpaN" >> $corps;EnD # params.
##
		Temps="`date '+%R'`"
		echo -e "cmd \"       <span color='$Color2'>━━━━━━━━</span>\" \"$MRUF\"\n
menu \"       <span rise='9000' font='$Caract bold $Size'><span color='$Color1'><i>$MenU</i>$SpaN2\"
	$LignESpaN
	cmd \"$DSeaGR<i> ⚫  $RefresH </i>$SpaN2\" \"mv -f $corps $corps.bkp\"
	cmd \" <-~ $EDT\" \"defaulttexteditor /tmp/recents\"
	cmd \"$DSeaGR<i> ⚫  $RebuilD     </i>$SpaN2\" \"rm -f $corps;rm /tmp/en-tete\"
	$LignESpaN\nend\ncmd \"   $mAj $Temps \" \" \"" >> $corps
##
		DirBkp="$PWD";cd /tmp
		for i in dir-catalog* MRUD* MRUF* scr*.xbel liste-PPM # Menu*i*, non # liste-M*, non plus.
			do rm -f $i 2>/dev/null
		done # Nettoyage / Clean-up
		cd $DirBkp

		ls -Algo $XBelsrc | awk '{ print $3 }' > $MRUFrep/share/MRUF/XbelSize # Size stamps for xbel file &
		ls -AlgoH $MRUF | awk '{ print $3 }' > $MRUFrep/share/MRUF/ScriptSize # script,
		ls -Algo ~/.config/geany/geany.conf | awk '{ print $3 }' > ~/.config/geany/Size.geany.conf
		ls -Algo ~/.mtpaint | awk '{ print $3 }' > ~/Size.mtpaint # geany and mtpaint config files.
##
		RPLCT="replaceit --input=$corps"
		$RPLCT "/initrd/mnt/dev_save" "/mnt/home" # Retouches pour raccourcir les
		$RPLCT "/initrd/mnt/tmpfs/tmp" "/tmp" #  lignes. / Touch-ups to shorten lines.
		$RPLCT "/mnt/sda1/DpupStretch-7.0b/yaya/my-documents" "/root/my-documents"

		TailleActive="`cat $MRUFrep/share/MRUF/Size`"
		$RPLCT "$TailleActive"  "$TailleActive  ««--" "}echo" "-span"
		CouleurActive="`ls -1 $MRUFrep/share/MRUF/*§Active | awk -F"§" '{ print $1 }' | awk -F"\/" '{ print $NF }'`"
		$RPLCT "$CouleurActive" "$CouleurActive  ««--" "{cmd"

		cat /tmp/en-tete $corps > /tmp/recents
	fi
### Fin du / End of / menu ###

	LC_ALL="" # Back to default value. / Retour à la valeur par défaut.
#
# Un menu de +/- 50 Ko prend maintenant de 2,71 à 3,24 secondes à se créer. /
# A +/- 50 Kb menu now takes from 2.71 to 3,24 seconds to be created. (2017/08/11)
#
	aemenu-pango -rc /tmp/recents &>/dev/null ;; # Affichage / We show the menu.
esac
rm -f /tmp/MZ*s
PATH="$PATHBKP" # set +xe
